Index: drivers/scsi/nsp32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/nsp32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/nsp32.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/nsp32.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -1346,10 +1302,10 @@
 		/* Selection Timeout, go busfree phase. */
 		if (auto_stat & SELECTION_TIMEOUT) {
 			nsp32_dbg(NSP32_DEBUG_INTR,
-				  "selection timeout occured");
+				  "selection timeout occurred");
 
 			SCpnt->result = DID_TIME_OUT << 16;
-			nsp32_scsi_done(data, SCpnt);
+			nsp32_scsi_done(SCpnt);
 			goto out;
 		}
 
@@ -1357,17 +1313,17 @@
 			/*
 			 * MsgOut phase was processed.
 			 * If MSG_IN_OCCUER is not set, then MsgOut phase is
-			 * completed. Thus, msgoutlen must reset.  Otherwise,
-			 * nothing to do here. If MSG_OUT_OCCUER is occured,
+			 * completed. Thus, msgout_len must reset.  Otherwise,
+			 * nothing to do here. If MSG_OUT_OCCUER is occurred,
 			 * then we will encounter the condition and check.
 			 */
 			if (!(auto_stat & MSG_IN_OCCUER) &&
-			     (data->msgoutlen <= 3)) {
+			     (data->msgout_len <= 3)) {
 				/*
-				 * !MSG_IN_OCCUER && msgoutlen <=3
+				 * !MSG_IN_OCCUER && msgout_len <=3
 				 *   ---> AutoSCSI with MSGOUTreg is processed.
 				 */
-				data->msgoutlen = 0;
+				data->msgout_len = 0;
 			};
 
 			nsp32_dbg(NSP32_DEBUG_INTR, "MsgOut phase processed");
@@ -1394,28 +1350,29 @@
 				    nsp32_read4(base, SACK_CNT));
 			nsp32_dbg(NSP32_DEBUG_INTR, "SSACK=0x%lx", 
 				    nsp32_read4(base, SAVED_SACK_CNT));
-			
+
+			SCpnt->resid = 0; /* all data transfered! */
 		}
 
 		/*
 		 * MsgIn Occur
 		 */
 		if (auto_stat & MSG_IN_OCCUER) {
-			nsp32_msgin_occur(data, irq_stat, auto_stat);
+			nsp32_msgin_occur(SCpnt, irq_stat, auto_stat);
 		}
 
 		/*
 		 * MsgOut Occur
 		 */
 		if (auto_stat & MSG_OUT_OCCUER) {
-			nsp32_msgout_occur(data);
+			nsp32_msgout_occur(SCpnt);
 		}
 
 		/*
 		 * Bus Free Occur
 		 */
 		if (auto_stat & BUS_FREE_OCCUER) {
-			ret = nsp32_busfree_occur(data, auto_stat);
+			ret = nsp32_busfree_occur(SCpnt, auto_stat);
 			if (ret == TRUE) {
 				goto out;
 			}
@@ -1466,28 +1423,28 @@
 
 		switch(busphase) {
 		case BUSPHASE_DATA_OUT:
-			printk( "write\n");
+			nsp32_dbg(NSP32_DEBUG_INTR, "fifo/write");
 
 			//nsp32_pio_write(SCpnt);
 
 			break;
 
 		case BUSPHASE_DATA_IN:
-			printk( "read\n");
+			nsp32_dbg(NSP32_DEBUG_INTR, "fifo/read");
 
 			//nsp32_pio_read(SCpnt);
 
 			break;
 
 		case BUSPHASE_STATUS:
-			//DEBUG(0, "fifo/status\n");
+			nsp32_dbg(NSP32_DEBUG_INTR, "fifo/status");
 
 			SCpnt->SCp.Status = nsp32_read1(base, SCSI_CSB_IN);
 
 			break;
 		default:
-			printk("fifo/other phase?\n");
-			printk("irq_stat=0x%x trans_stat=0x%x\n", irq_stat, trans_stat);
+			nsp32_dbg(NSP32_DEBUG_INTR, "fifo/other phase");
+			nsp32_dbg(NSP32_DEBUG_INTR, "irq_stat=0x%x trans_stat=0x%x", irq_stat, trans_stat);
 			show_busphase(busphase);
 			break;
 		}
@@ -1502,7 +1459,7 @@
 		switch(busphase) {
 		case BUSPHASE_MESSAGE_IN:
 			nsp32_dbg(NSP32_DEBUG_INTR, "phase chg/msg in");
-			nsp32_msgin_occur(data, irq_stat, 0);
+			nsp32_msgin_occur(SCpnt, irq_stat, 0);
 			break;
 		default:
 			nsp32_msg(KERN_WARNING, "phase chg/other phase?");
@@ -1516,7 +1473,7 @@
 
 	/* PCI_IRQ */
 	if (irq_stat & IRQSTATUS_PCI_IRQ) {
-		nsp32_dbg(NSP32_DEBUG_INTR, "PCI IRQ occured");
+		nsp32_dbg(NSP32_DEBUG_INTR, "PCI IRQ occurred");
 		/* Do nothing */
 	}
 
@@ -1525,13 +1482,14 @@
 		nsp32_msg(KERN_ERR, "Received unexpected BMCNTERR IRQ! ");
 		/*
 		 * TODO: To be implemented improving bus master
-		 * transfer reliablity when BMCNTERR is occured in
+		 * transfer reliablity when BMCNTERR is occurred in
 		 * AutoSCSI phase described in specification.
 		 */
 	}
 
 #if 0
-	printk("irq_stat=0x%x trans_stat=0x%x\n", irq_stat, trans_stat);
+	nsp32_dbg(NSP32_DEBUG_INTR,
+		  "irq_stat=0x%x trans_stat=0x%x", irq_stat, trans_stat);
 	show_busphase(busphase);
 #endif
 
@@ -1540,72 +1498,122 @@
 	nsp32_write2(base, IRQ_CONTROL, 0);
 
  out2:
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
-	spin_unlock_irqrestore(&io_request_lock, flags);
-#else
-	spin_unlock_irqrestore(host->host_lock, flags);
-#endif
+	spin_unlock_irqrestore(HOST_LOCK, flags);
 
 	nsp32_dbg(NSP32_DEBUG_INTR, "exit");
 
-	return;
+	return IRQ_RETVAL(handled);
 }
 
 #undef SPRINTF
 #define SPRINTF(args...) \
-        do { if(pos < buffer + length) pos += sprintf(pos, ## args); } while(0)
-static int nsp32_proc_info(char  *buffer,
-			   char **start,
-			   off_t  offset,
-			   int    length,
-			   int    hostno,
-			   int    inout)
+	do { \
+		if(length > (pos - buffer)) { \
+			pos += snprintf(pos, length - (pos - buffer) + 1, ## args); \
+			nsp32_dbg(NSP32_DEBUG_PROC, "buffer=0x%p pos=0x%p length=%d %d\n", buffer, pos, length,  length - (pos - buffer));\
+		} \
+	} while(0)
+static int nsp32_proc_info(
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73)) 
+	struct Scsi_Host *host,
+#endif
+	char             *buffer,
+	char            **start,
+	off_t             offset,
+	int               length,
+#if !(LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73)) 
+	int               hostno,
+#endif
+	int               inout)
 {
-	char *pos = buffer;
-	int thislength;
-	unsigned long flags;
-	nsp32_hw_data *data;
-	struct Scsi_Host *host = NULL;
-	unsigned int base;
-	unsigned char mode_reg;
+	char             *pos = buffer;
+	int               thislength;
+	unsigned long     flags;
+	nsp32_hw_data    *data;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73)) 
+	int               hostno;
+#else
+	struct Scsi_Host *host;
+#endif
+	unsigned int      base;
+	unsigned char     mode_reg;
+	int               id, speed;
+	long              model;
 
 	/* Write is not supported, just return. */
 	if (inout == TRUE) {
 		return -EINVAL;
 	}
 
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73)) 
+	hostno = host->host_no;
+#else
 	/* search this HBA host */
-	for (host=scsi_hostlist; host; host=host->next) {
-		if (host->host_no == hostno) {
-			break;
-		}
-	}
+	host = scsi_host_hn_get(hostno);
 	if (host == NULL) {
 		return -ESRCH;
 	}
+#endif
 	data = (nsp32_hw_data *)host->hostdata;
 	base = host->io_port;
 
 	SPRINTF("NinjaSCSI-32 status\n\n");
-	SPRINTF("Driver version:        %s\n",		nsp32_release_version);
+	SPRINTF("Driver version:        %s, $Revision: 1.2 $\n", nsp32_release_version);
 	SPRINTF("SCSI host No.:         %d\n",		hostno);
 	SPRINTF("IRQ:                   %d\n",		host->irq);
 	SPRINTF("IO:                    0x%lx-0x%lx\n", host->io_port, host->io_port + host->n_io_port - 1);
-	SPRINTF("MMIO(virtual address): 0x%lx\n",	host->base);
+	SPRINTF("MMIO(virtual address): 0x%lx-0x%lx\n",	host->base, host->base + data->MmioLength - 1);
 	SPRINTF("sg_tablesize:          %d\n",		host->sg_tablesize);
-	SPRINTF("Chip revision:         %d\n",		(nsp32_read2(base, INDEX_REG) >> 8) - 0x4f);
+	SPRINTF("Chip revision:         0x%x\n",       	(nsp32_read2(base, INDEX_REG) >> 8) & 0xff);
 
 	mode_reg = nsp32_index_read1(base, CHIP_MODE);
+	model    = data->pci_devid->driver_data;
 
 #ifdef CONFIG_PM
-	//SPRINTF("Power Management:      %s\n",          (mode_reg & OPTF) ? "yes" : "no");
+	SPRINTF("Power Management:      %s\n",          (mode_reg & OPTF) ? "yes" : "no");
 #endif
-	SPRINTF("OEM:                   %s\n",          nsp32_model[mode_reg & (OEM0|OEM1)]);
+	SPRINTF("OEM:                   %ld, %s\n",     (mode_reg & (OEM0|OEM1)), nsp32_model[model]);
 
 	spin_lock_irqsave(&(data->Lock), flags);
 	SPRINTF("CurrentSC:             0x%p\n\n",      data->CurrentSC);
 	spin_unlock_irqrestore(&(data->Lock), flags);
 
+
+	SPRINTF("SDTR status\n");
+	for(id = 0; id < NUMBER(data->target); id++) {
+
+                SPRINTF("id %d: ", id);
+
+		if (id == host->this_id) {
+			SPRINTF("----- NinjaSCSI-32 host adapter\n");
+			continue;
+		}
+
+		if (data->target[id].sync_flag == SDTR_DONE) {
+			if (data->target[id].period == 0            &&
+			    data->target[id].offset == ASYNC_OFFSET ) {
+				SPRINTF("async");
+			} else {
+				SPRINTF(" sync");
+			}
+		} else {
+			SPRINTF(" none");
+		}
+
+		if (data->target[id].period != 0) {
+
+			speed = 1000000 / (data->target[id].period * 4);
+
+			SPRINTF(" transfer %d.%dMB/s, offset %d",
+				speed / 1000,
+				speed % 1000,
+				data->target[id].offset
+				);
+		}
+		SPRINTF("\n");
+	}
+
+
 	thislength = pos - (buffer + offset);
 
 	if(thislength < 0) {
